/*
 *  Copyright 2025-2026 R3944Realms
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package top.r3944realms.eroticdungeongame.mixin.minecraft;

import com.llamalad7.mixinextras.injector.wrapmethod.WrapMethod;
import com.llamalad7.mixinextras.injector.wrapoperation.Operation;
import com.llamalad7.mixinextras.injector.wrapoperation.WrapOperation;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import org.jetbrains.annotations.NotNull;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Redirect;
import top.r3944realms.eroticdungeongame.api.workspace.Services;
import top.r3944realms.eroticdungeongame.content.entity.npc.INPCPlayer;

import java.util.UUID;

@Mixin(Player.class)
public abstract class MixinPlayer extends LivingEntity {
    protected MixinPlayer(EntityType<? extends LivingEntity> entityType, Level level) {
        super(entityType, level);
    }
    @Redirect(
            method = "<init>",
            at = @At(
                    value = "INVOKE",
                    target = "Lnet/minecraft/world/entity/player/Player;setUUID(Ljava/util/UUID;)V"
            )
    )
    private void edg$Player$setUUID(Player instance, UUID uuid) {
        if (!(instance instanceof INPCPlayer)) {
            instance.setUUID(uuid);
        }
    }
    @WrapMethod(method = "shouldShowName")
    public boolean edg$shouldShowName(@NotNull Operation<Boolean> original) {
        Player player = Player.class.cast(this);
        return Services.WORK_SPACE.tryToDoIfInDeviceAndRet(player, data -> false, original::call);
    }

    @WrapMethod(method = "wantsToStopRiding")
    private boolean edg$wantToStopRide(@NotNull Operation<Boolean> original) {
        Player player = Player.class.cast(this);
        return Services.WORK_SPACE.tryToDoIfInDeviceAndRet(player, data -> false, original::call);
    }
    @WrapOperation(
            method = "readAdditionalSaveData",
            at = @At(
                    value = "INVOKE",
                    target = "Lnet/minecraft/world/entity/player/Player;setUUID(Ljava/util/UUID;)V"
            )
    )
    private void edg$readAdditionalSaveData$setUUID(Player instance, UUID uuid, Operation<Void> original) {
        if (!(instance instanceof INPCPlayer)) {
            original.call(instance, uuid);
        }
    }

}
